#include"disp.h"
#include"sound.h"
using namespace std;
const double scrspd = 0.1;
const double scrrotspd = 0.001;
const long loopmax = 16;
const long looptmax = 6;
const double balldef = 6;
const double loopdef = 60;
const double loopdef1 = 90;
const double tridef = 10;
struct vector
{
    double x;
    double y;
};
struct tloop
{
    bool b;
    double x;
    double y;
    double r;
    long c;
    long n;
    long tt;
    double tp;
    long tn;
    double ta[looptmax * 2];
    long te[looptmax * 2];
};
struct tball
{
    bool b;
    double a;
    double t;
    double r;
    long e;
    long c;
};
long sbg;
long sj1;
long sj2;
long sj3;
long sj4;
bool fpsb;
long w = 800;
long h = 600;
double ftimedraw;
double ftimestep;
double ftimeball;
double framedraw;
double framestep;
long rnd;
long rndt;
bool spaceb;
bool initb;
bool autob;
double spdmul;
double spd;
vector rotp;
vector scrp;
vector scrloopp;
double scrrot;
double ballexp;
tball ball;
long loopstp;
tloop loop[loopmax];
long loopj;
long loopl;
long loopn;
long loopcn;
long loopci;
vector loopp;
vector ballp;
double angle;
double linep;
long linec;
void setaudiofrqall(double frq)
{
    setaudiofrq(sbg, frq);
    setaudiofrq(sj1, frq);
    setaudiofrq(sj2, frq);
    setaudiofrq(sj3, frq);
    setaudiofrq(sj4, frq);
}
void setaudioloop(double loopstart, double loopend)
{
    if (getaudiopos(sbg) > loopstart )setaudiopos(sbg, loopend);
}
void rotate(double &x, double &y)
{
    rotp.x = (x - scrp.x) * cos(scrrot) - (y - scrp.y) * sin(scrrot) + w / 2;
    rotp.y = (x - scrp.x) * sin(scrrot) + (y - scrp.y) * cos(scrrot) + h / 2;
    x = rotp.x;
    y = rotp.y;
}
void rotate(vector &p)
{
    rotate(p.x, p.y);
}
void drawtri(long x, long y, long r, double a, long cfg, long cbg, long e)
{
    double trix0;
    double triy0;
    double trix1;
    double triy1;
    double trix2;
    double triy2;
    double trix3;
    double triy3;
    double tricos;
    double trisin;
    trisin = tridef / r;
    tricos = sqrt(1 - trisin * trisin);
    trix1 = x + (sin(a) * tricos + cos(a) * trisin) * r;
    triy1 = y + (cos(a) * tricos - sin(a) * trisin) * r;
    trix2 = x + (sin(a) * tricos - cos(a) * trisin) * r;
    triy2 = y + (cos(a) * tricos + sin(a) * trisin) * r;
    trix0 = (trix1 + trix2) / 2 - x;
    triy0 = (triy1 + triy2) / 2 - y;
    trix3 = x + sin(a) * (abs(trix0, triy0) - tridef * 2 * e);
    triy3 = y + cos(a) * (abs(trix0, triy0) - tridef * 2 * e);
    rotate(trix1, triy1);
    rotate(trix2, triy2);
    rotate(trix3, triy3);
    triangle((long)trix1, (long)triy1, (long)trix2, (long)triy2, (long)trix3, (long)triy3, cfg, linep < trix0 + x ? cbg : gray);
}
void drawcircle(double x, double y, double r, long c)
{
    double circleangle;
    if (linep <= x - r)
    {
        circle(loopp.x, loopp.y, r, c, transparent);
    }
    else if (linep >= x + r)
    {
        circle(loopp.x, loopp.y, r, gray, transparent);
    }
    else
    {
        circleangle = arccos((linep - x) / r);
        arc(loopp.x, loopp.y, r, r, +circleangle + scrrot, -circleangle + scrrot, c, transparent);
        arc(loopp.x, loopp.y, r, r, -circleangle + scrrot, +circleangle + scrrot, gray, transparent);
    }
}
void drawloop()
{
    for (long loopi = 0; loopi < loopmax; loopi++)
    {
        if (loop[loopi].b)
        {
            loopp.x = loop[loopi].x;
            loopp.y = loop[loopi].y;
            if (loopi == loopl)
            {
                loopp.x = scrloopp.x;
                loopp.y = scrloopp.y;
            }
            for (long trii = 0; trii < loop[loopi].tn; trii++)
            {
                drawtri(loopp.x, loopp.y, loop[loopi].r, loop[loopi].ta[trii], transparent, loop[loopi].c, loop[loopi].te[trii]);
            }
            rotate(loopp);
            drawcircle(loop[loopi].x, loop[loopi].y, loop[loopi].r, loop[loopi].c);
            if (loop[loopi].n % loopstp == 0)
            {
                for (long loopdbl = min(10, loop[loopi].n / loopstp / loopcn); loopdbl >= 0; loopdbl--)
                {
                    drawcircle(loop[loopi].x, loop[loopi].y, loop[loopi].r - (loopdbl + 1) * 4, loop[loopi].c);
                }
            }
            setfontsize(20, 40);
            drawtextxy(i2s(loop[loopi].n), loopp.x - getstringwidth(i2s(loop[loopi].n)) / 2, loopp.y - getstringheight(i2s(loop[loopi].n)) / 2, (linep < loop[loopi].x) ? loop[loopi].c : gray);
        }
    }
}
void getballp()
{
    double ballangle;
    ballangle = (ftimestep * 100.0 / loop[loopj].r - ball.a) * spd * ball.c;
    if (ball.b == false)ballangle = (ball.t - ball.a) * spd * ball.c;
    ballp.x = loop[loopj].x + sin(ballangle) * (loop[loopj].r - ball.r * ball.e);
    ballp.y = loop[loopj].y + cos(ballangle) * (loop[loopj].r - ball.r * ball.e);
}
void drawball()
{
    getballp();
    rotate(ballp);
    if (ball.b)
    {
        circle(ballp.x, ballp.y, ball.r, white);
    }
    else
    {
        ballexp = ball.r - (ftimestep - ftimeball) * spd * 10;
        circle(ballp.x, ballp.y, max(0, ballexp), loop[loopj].c);
    }
}
void drawline()
{
    double linex1;
    double liney1;
    double linex2;
    double liney2;
    linex1 = linex2 = linep;
    liney1 = -(liney2 = abs(w , h) / 2);
    rotate(linex1, liney1);
    rotate(linex2, liney2);
    line(linex1, liney1, linex2 - linex1, liney2 - liney1, loop[linec].c);
}
void drawfps()
{
    if (fpsb)
    {
        setfontsize(10, 20);
        drawtextxy(i2s(getfps()), 0, 0, gray);
    }
}
void drawall()
{
    clear();
    drawloop();
    drawball();
    drawline();
    drawfps();
    freshwin();
}
bool istri(long i)
{
    angle = (ftimestep * 100.0 / loop[loopj].r - ball.a) * spd * ball.c - loop[loopj].ta[i];
    while (angle < -pi)angle += 2 * pi;
    while (angle > +pi)angle -= 2 * pi;
    return ((abs(angle) < tridef / loop[loopj].r) && (loop[loopj].te[i] == ball.e));
}
bool istri()
{
    for (long trii = 0; trii < loop[loopj].tn; trii++)
    {
        if (istri(trii))
        {
            return true;
        }
    }
    return false;
}
bool isloop(long loopk)
{
    if (loopk == loopj)
    {
        return false;
    }
    if (loop[loopk].b)
    {
        angle = (ftimestep * 100.0 / loop[loopj].r - ball.a) * spd * ball.c;
        if ((ftimestep * 100.0 / loop[loopj].r - ball.t) * spd < pi / 2.0)return false;
        loopp.x = loop[loopj].x + sin(angle) * (loop[loopj].r - ball.r * -1);
        loopp.y = loop[loopj].y + cos(angle) * (loop[loopj].r - ball.r * -1);
        return ball.r + loop[loopk].r > abs(loop[loopk].x - loopp.x, loop[loopk].y - loopp.y);
    }
    return false;
}
long isloop()
{
    for (long loopi = 0; loopi < loopmax; loopi++)
    {
        if (isloop(loopi))
        {
            return loopi;
        }
    }
    return -1;
}
bool isline()
{
    getballp();
    return ballp.x < linep;
}
void jump(long loopk)
{
    vector jumpp;
    setaudiofrqall((float)min(24.0, (double)(loop[loopk].n / loopstp) / 3.0 - 4.0));
    spd = (2.0 + min(5.0, loop[loopk].n / loopstp * 0.05)) * spdmul;
    jumpp.x = loop[loopj].x - loop[loopk].x;
    jumpp.y = loop[loopj].y - loop[loopk].y;
    angle = atan2(jumpp.x * ball.c , jumpp.y) / spd;
    ball.a = ftimestep * 100.0 / loop[loopk].r + angle;
    ball.t = ftimestep * 100.0 / loop[loopk].r;
    ball.c = -ball.c;
    loopj = loopk;
}
void space()
{
    spaceb = false;
    if (ball.b == false)
    {
        if (ballexp < 0)initb = true;
    }
    else
    {
        if (ball.e == 1 && isloop() != -1)
        {
            jump(isloop());
            playaudio(sj3);
        }
        else
        {
            if (ball.e < 0)playaudio(sj1);
            if (ball.e > 0)playaudio(sj2);
            ball.e = -ball.e;
        }
    }
}
void kill()
{
    if (ball.b)
    {
        ball.t = ftimestep * 100.0 / loop[loopj].r;
        playaudio(sj4);
        ball.b = false;
        ftimeball = ftimestep;
    }
}
void autogame()
{
    if (istri())space();
    if (isloop() != -1)space();
}
void addloop(double x, double y, double r, long trin)
{
    angle = rand() / (double)RAND_MAX * pi;
    scrloopp.x = x + sin(angle) * loop[loopl].r * 8;
    scrloopp.y = y + cos(angle) * loop[loopl].r * 8;
    loopl = (loopl + 1) % loopmax;
    loop[loopl].b = true;
    loop[loopl].x = x;
    loop[loopl].y = y;
    loop[loopl].r = r;
    loop[loopl].c = hsn2rgb(0x00AAFF00 | long((double)loopci / (double)loopcn * 0xFF));
    loop[loopl].n = loopn;
    loop[loopl].tt = 0;
    loop[loopl].tn = r / 30;
    if (trin == 2)
    {
        if (loop[loopl].tn == 6)trin = 1;
        if (loop[loopl].tn == 5)trin = random(2) + 1;
    }
    rnd = random(2);
    for (long trii = 1; trii < loop[loopl].tn - 1; trii++)
    {
        for (long trij = 0; trij < trin; trij++)
        {
            loop[loopl].ta[trii - 1 + trij * (loop[loopl].tn - 2)] = pi * ((double)(trii + 0.5) / (double)(loop[loopl].tn) + loopl % 2) + pi / 2.0 + pi * trij;
            loop[loopl].te[trii - 1 + trij * (loop[loopl].tn - 2)] = (trii % 2 ^ (trii >= loop[loopl].tn / 2) & rnd) * 2 - 1;
        }
    }
    loop[loopl].tn -= 2;
    loop[loopl].tn *= trin;
    loopn++;
}
void addloop()
{
    if (loopn % loopstp == 0)
    {
        rnd = loopdef;
        loopci = (loopci + 1) % loopcn;
        rndt = 0;
    }
    else if (loopn == 1)
    {
        rnd = loopdef1;
        rndt = 1;
    }
    else
    {
        rnd = (random(looptmax) + 1) * 30;
        rndt = ((random(loopn / loopstp + loopcn)) > (loopcn - 1)) + 1;
    }
    addloop(loop[loopl].x + loop[loopl].r + rnd, loop[loopl].y, rnd, rndt);
}
void movescr()
{
    scrp.x += (loop[loopj].x - scrp.x) * scrspd;
    scrp.y += (loop[loopj].y - scrp.y) * scrspd;
    scrrot += (loop[loopj].n / loopstp % 2 * 2 - 1) * scrrotspd * (spd - 1) * (spd - 1);
    scrloopp.x += (loop[loopl].x - scrloopp.x) * scrspd * 2;
    scrloopp.y += (loop[loopl].y - scrloopp.y) * scrspd * 2;
}
void moveline()
{
    for (long loopi = 0; loopi < loopmax; loopi++)if (loop[loopi].n > loop[linec].n)if (linep >= loop[loopi].x - loop[loopi].r)linec = loopi;
    if (ball.b)
    {
        linep += (spd * 0.5);
        if (scrp.x - linep > abs(w, h) / 4)linep = linep += (spd * 0.1);
        if (scrp.x - linep > abs(w, h) / 3)linep = linep += (spd * 0.05);
        if (scrp.x - linep > abs(w, h) / 2)linep = scrp.x - abs(w, h) / 2;
    }
    if (loop[loopj].n % loopstp == 0)linep = min(linep, loop[loopj].x - loop[loopj].r);
}
void initloop()
{
    for (long loopi = 0; loopi < loopmax; loopi++)
    {
        loop[loopi].b = false;
        loop[loopi].x = 0;
        loop[loopi].y = 0;
        loop[loopi].r = 0;
        loop[loopi].c = 0;
        loop[loopi].n = 0;
        loop[loopi].tn = 0;
    }
    loopj = 1;
    loopl = 0;
    loopn = 0;
    loopci = 0;
    addloop(0, 0, loopdef, 0);
    playaudio(sbg,0);
    setaudiofrqall(-4.0);
}
void initball()
{
    ball.b = true;
    ball.a = ftimestep * 100.0 / loop[loopj].r + pi / spd;
    ball.t = ftimestep * 100.0 / loop[loopj].r;
    ball.r = balldef;
    ball.e = 1;
    ball.c = 1;
}
void initgame()
{
    scrp.x = 0;
    scrp.y = 0;
    scrrot = 0;
    spdmul = 1;
    spd = 2 * spdmul;
    loopstp = 5;
    loopcn = 20;
    initloop();
    initball();
    linep = -loop[loopj].r;
    linec = loopj;
    spaceb = false;
    initb = false;
    autob = false;
}
void step()
{
    movescr();
    moveline();
    if (initb)initgame();
    if (autob)autogame();
    if ((isloop() != -1 && ball.e == -1) || istri() || isline())kill();
    if (spaceb)space();
    if ((loop[(loopj + 1) % loopmax].x <= loop[loopj].x))addloop();
}
void act()
{
    if (iskey(k_space))spaceb = true;
    if (iskey(k_right))jump((loopj + 1) % loopmax);
    if (iskey(k_left))jump((loopj + loopmax - 1) % loopmax);
    if (iskey(k_up))loopstp = loopstp + 1;
    if (iskey(k_down))loopstp = max(1, loopstp - 1);
    if (iskey(k_add))spdmul *= sqrt(2);
    if (iskey(k_sub))spdmul /= sqrt(2);
    if (iskey(k_home))loopcn++;
    if (iskey(k_end))loopcn = max(1, loopcn - 1);
    if (iskey(k_r))initgame();
    if (iskey(k_f9))fpsb = !fpsb;
    if (iskey(k_f12))autob = !autob;
    if (iskey(k_esc))closewin();
}
void initwin()
{
    createwin(w, h);
    settitle("loop_ax");
    setpenwidth(2);
    setfontname("Consolas");
    framedraw = 60.0;
    framestep = 120.0;
    ftimedraw = gettimer();
    ftimestep = gettimer();
    fpsb = false;
}
void initsound()
{
    initaudio();
    sbg = loadaudio("audio/bg.mp3");
    sj1 = loadaudio("audio/sj1.wav");
    sj2 = loadaudio("audio/sj2.wav");
    sj3 = loadaudio("audio/sj3.wav");
    sj4 = loadaudio("audio/sj4.wav");
}
void init()
{
    randomize();
    initsound();
    initwin();
    initgame();
}
int main()
{
    init();
    while (iswin())
    {
        setaudioloop(82.33, 27.49);
        if (isnextmsg())
        {
            act();
        }
        else
        {
            delay(1);
        }
        while (gettimer() > ftimestep + 1 / framestep)
        {
            step();
            ftimestep = ftimestep + 1 / framestep;
        }
        if (gettimer() > ftimedraw + 1 / framedraw)
        {
            while (gettimer() > ftimedraw + 1 / framedraw)
            {
                ftimedraw = ftimedraw + 1 / framedraw;
            }
            drawall();
        }
    }
    return 0;
}